//### This file created by BYACC 1.8(/Java extension  1.1)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//### Please send bug reports to rjamison@lincom-asg.com
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.structs.*;
import com.thoughtworks.qdox.model.*;
import com.thoughtworks.qdox.model.annotation.*;
import java.io.IOException;
import java.util.LinkedList;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;
//#line 25 "Parser.java"




/**
 * Encapsulates yacc() parser functionality in a Java
 *        class for quick code development
 */
public class Parser
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[],stateptr;           //state stack
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
void state_push(int state)
{
  if (stateptr>=YYSTACKSIZE)         //overflowed?
    return;
  statestk[++stateptr]=state;
  if (stateptr>statemax)
    {
    statemax=state;
    stateptrmax=stateptr;
    }
}
int state_pop()
{
  if (stateptr<0)                    //underflowed?
    return -1;
  return statestk[stateptr--];
}
void state_drop(int cnt)
{
int ptr;
  ptr=stateptr-cnt;
  if (ptr<0)
    return;
  stateptr = ptr;
}
int state_peek(int relative)
{
int ptr;
  ptr=stateptr-relative;
  if (ptr<0)
    return -1;
  return statestk[ptr];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
boolean init_stacks()
{
  statestk = new int[YYSTACKSIZE];
  stateptr = -1;
  statemax = -1;
  stateptrmax = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
void val_init()
{
  valstk=new Value[YYSTACKSIZE];
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
void val_push(Value val)
{
  if (valptr>=YYSTACKSIZE)
    return;
  valstk[++valptr]=val;
}
Value val_pop()
{
  if (valptr<0)
    return null;
  return valstk[valptr--];
}
void val_drop(int cnt)
{
int ptr;
  ptr=valptr-cnt;
  if (ptr<0)
    return;
  valptr = ptr;
}
Value val_peek(int relative)
{
int ptr;
  ptr=valptr-relative;
  if (ptr<0)
    return null;
  return valstk[ptr];
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short DOTDOTDOT=259;
public final static short COMMA=260;
public final static short STAR=261;
public final static short PERCENT=262;
public final static short EQUALS=263;
public final static short ANNOSTRING=264;
public final static short ANNOCHAR=265;
public final static short SLASH=266;
public final static short PLUS=267;
public final static short MINUS=268;
public final static short PACKAGE=269;
public final static short IMPORT=270;
public final static short PUBLIC=271;
public final static short PROTECTED=272;
public final static short PRIVATE=273;
public final static short STATIC=274;
public final static short FINAL=275;
public final static short ABSTRACT=276;
public final static short NATIVE=277;
public final static short STRICTFP=278;
public final static short SYNCHRONIZED=279;
public final static short TRANSIENT=280;
public final static short VOLATILE=281;
public final static short CLASS=282;
public final static short INTERFACE=283;
public final static short ENUM=284;
public final static short ANNOINTERFACE=285;
public final static short THROWS=286;
public final static short EXTENDS=287;
public final static short IMPLEMENTS=288;
public final static short SUPER=289;
public final static short DEFAULT=290;
public final static short BRACEOPEN=291;
public final static short BRACECLOSE=292;
public final static short SQUAREOPEN=293;
public final static short SQUARECLOSE=294;
public final static short PARENOPEN=295;
public final static short PARENCLOSE=296;
public final static short LESSTHAN=297;
public final static short GREATERTHAN=298;
public final static short LESSEQUALS=299;
public final static short GREATEREQUALS=300;
public final static short LESSTHAN2=301;
public final static short GREATERTHAN2=302;
public final static short GREATERTHAN3=303;
public final static short EXCLAMATION=304;
public final static short AMPERSAND2=305;
public final static short VERTLINE2=306;
public final static short EQUALS2=307;
public final static short NOTEQUALS=308;
public final static short TILDE=309;
public final static short AMPERSAND=310;
public final static short VERTLINE=311;
public final static short CIRCUMFLEX=312;
public final static short VOID=313;
public final static short QUERY=314;
public final static short COLON=315;
public final static short AT=316;
public final static short JAVADOCSTART=317;
public final static short JAVADOCEND=318;
public final static short JAVADOCEOL=319;
public final static short CODEBLOCK=320;
public final static short PARENBLOCK=321;
public final static short BYTE=322;
public final static short SHORT=323;
public final static short INT=324;
public final static short LONG=325;
public final static short CHAR=326;
public final static short FLOAT=327;
public final static short DOUBLE=328;
public final static short BOOLEAN=329;
public final static short IDENTIFIER=330;
public final static short JAVADOCTAG=331;
public final static short JAVADOCLINE=332;
public final static short BOOLEAN_LITERAL=333;
public final static short INTEGER_LITERAL=334;
public final static short LONG_LITERAL=335;
public final static short FLOAT_LITERAL=336;
public final static short DOUBLE_LITERAL=337;
public final static short CHAR_LITERAL=338;
public final static short STRING_LITERAL=339;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,   35,    0,   34,   34,   34,   34,   34,   34,   34,
   36,   37,   37,   38,   41,   43,   43,   44,   42,   42,
   46,   45,   23,   23,   23,   31,   28,   28,   24,   24,
   24,   24,   24,   24,   24,   24,   24,   24,   24,   47,
   47,   47,   47,   49,    6,   48,   48,   48,   48,   50,
   50,   51,   52,    7,   53,   53,   54,   54,    3,    3,
    3,    4,    8,    8,    9,    9,   10,   10,   11,   11,
   12,   12,   13,   13,   14,   14,   14,   15,   15,   15,
   15,   15,   16,   16,   16,   16,   17,   17,   17,   18,
   18,   18,   18,   19,   19,   19,   20,   20,   20,   21,
   21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
   22,   22,    1,    1,    5,    5,    5,    5,    5,    5,
    5,    2,    2,    2,    2,    2,    2,    2,    2,   30,
   56,   57,   32,   32,   25,   25,   26,   26,   55,   55,
   33,   33,   33,   33,   58,   58,   61,   59,   60,   60,
   62,   64,   62,   63,   63,   40,   65,   66,   66,   68,
   68,   68,   70,   70,   72,   72,   72,   72,   39,   73,
   74,   74,   74,   75,   75,   76,   76,   67,   67,   77,
   77,   69,   79,   69,   78,   78,   78,   78,   78,   78,
   78,   78,   27,   27,   83,   85,   80,   84,   86,   84,
   87,   84,   89,   81,   91,   81,   92,   82,   88,   90,
   90,   94,   94,   93,   93,   95,   95,   96,   29,   29,
   71,   71,   97,   97,
};
final static short yylen[] = {                            2,
    0,    0,    3,    1,    1,    1,    1,    1,    1,    1,
    3,    3,    4,    4,    1,    0,    2,    1,    0,    2,
    0,    3,    1,    3,    3,    2,    0,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    2,    2,    0,    0,    4,    0,    3,    3,    2,    1,
    3,    3,    0,    4,    0,    1,    1,    3,    1,    1,
    1,    1,    1,    5,    1,    3,    1,    3,    1,    3,
    1,    3,    1,    3,    1,    3,    3,    1,    3,    3,
    3,    3,    1,    3,    3,    3,    1,    3,    3,    1,
    3,    3,    3,    2,    2,    1,    2,    2,    1,    4,
    5,    5,    4,    3,    1,    4,    3,    3,    4,    1,
    2,    3,    1,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    0,    0,    6,    1,    1,    3,    1,    3,    1,    3,
    1,    1,    3,    3,    0,    1,    0,    4,    1,    3,
    1,    0,    4,    1,    3,    4,    4,    1,    3,    0,
    1,    3,    3,    2,    1,    2,    2,    3,    4,    6,
    1,    1,    1,    0,    2,    1,    3,    0,    2,    1,
    3,    0,    0,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,    0,    6,    0,    0,    4,
    0,    5,    0,    9,    0,    8,    0,    6,    3,    0,
    2,    1,    3,    0,    1,    1,    3,    5,    0,    1,
    0,    2,    0,    2,
};
final static short yydefred[] = {                         1,
    2,    0,   10,    0,    0,    0,   16,    4,    3,    5,
    6,    7,    8,    9,    0,    0,    0,   23,    0,    0,
    0,  113,    0,   19,    0,   29,   30,   31,   32,   33,
   34,   35,   39,   36,   38,   37,  171,  172,    0,  173,
   41,   40,   42,    0,    0,  182,   11,    0,    0,   12,
    0,    0,    0,   18,   17,    0,    0,  221,    0,    0,
    0,    0,    0,   25,   24,   13,  114,    0,   45,   14,
   21,   20,    0,  157,  147,    0,  146,    0,  156,  182,
    0,    0,  222,  164,  169,    0,    0,    0,    0,   49,
    0,    0,  123,  124,  125,  126,  127,  128,  129,  122,
    0,  119,  118,  117,  116,  115,  120,  121,    0,    0,
    0,   59,  105,   60,   61,   62,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   90,   96,   99,    0,
   50,    0,   16,  137,    0,    0,    0,    0,    0,    0,
    0,  163,    0,  162,  166,    0,  192,  185,  190,  191,
    0,  184,  186,  187,  188,  189,   94,   95,    0,    0,
    0,   98,   97,    0,    0,    0,    0,    0,    0,   47,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   48,    0,    0,  131,    0,    0,    0,    0,    0,
  149,    0,    0,  170,  168,  195,    0,    0,    0,    0,
    0,    0,    0,    0,  104,   52,  108,  111,    0,    0,
  107,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   91,
   93,   92,    0,   51,   57,    0,    0,    0,  138,  136,
    0,  152,    0,  148,    0,    0,    0,  196,    0,    0,
  103,    0,  100,    0,  109,  112,  106,    0,   54,    0,
    0,  141,  139,    0,    0,  150,    0,    0,    0,    0,
    0,  198,    0,  203,  102,  101,   64,   58,    0,    0,
    0,    0,  154,    0,    0,    0,    0,  216,    0,    0,
   27,    0,   28,    0,  143,  144,  140,  133,    0,    0,
  209,  221,    0,    0,  193,  194,  208,    0,    0,  197,
   27,  155,  224,    0,  217,    0,    0,  201,    0,    0,
  220,    0,    0,  206,    0,   27,  200,    0,  218,  202,
  204,
};
final static short yydgoto[] = {                          1,
  109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
  129,  167,   19,   42,  135,  136,  317,  280,  332,  272,
  258,  209,  273,    9,    2,   10,   11,   43,   13,   14,
   24,   53,   25,   55,   72,  133,   15,   69,   52,  130,
  131,  132,  246,  247,  274,  248,  292,   76,   77,  200,
  139,  201,  294,  275,   16,   59,   74,   60,   63,   61,
   62,   84,   17,   44,  141,  203,  138,  152,   86,  153,
  154,  155,  156,  302,  282,  329,  335,  279,  304,  300,
  281,  256,  296,  314,  297,  298,  310,
};
final static short yysindex[] = {                         0,
    0, -194,    0, -296, -258, -275,    0,    0,    0,    0,
    0,    0,    0,    0,  846, -131, -115,    0,   72, -296,
  138,    0, -193,    0, -151,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -143,    0,
    0,    0,    0, -103,  -88,    0,    0, -237,  147,    0,
  -63,  -48,  -69,    0,    0,    6,   54,    0,   67,  104,
  127, -202,  106,    0,    0,    0,    0, -127,    0,    0,
    0,    0,   71,    0,    0,  123,    0, -202,    0,    0,
  -88,  170,    0,    0,    0, -226,  135,  135,  135,    0,
  135,  135,    0,    0,    0,    0,    0,    0,    0,    0,
  168,    0,    0,    0,    0,    0,    0,    0, -128, -121,
  126,    0,    0,    0,    0,    0,   14,  130,  142,  137,
  128,  159, -180,   76,  225,   83,    0,    0,    0, -135,
    0,  165,    0,    0,  220,  242,  260,  259,  192,   71,
    6,    0,    0,    0,    0,  205,    0,    0,    0,    0,
  204,    0,    0,    0,    0,    0,    0,    0, -154, -123,
  230,    0,    0,   90, -262,  233,  -70,  247,  -41,    0,
  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
  135,  135,  135,  135,  135,  135,  135,  135,  135,  135,
  200,    0,   90, -151,    0,  201,  202,   71,  246, -250,
    0,  260,  286,    0,    0,    0,    0,  218,  260,   71,
  842,  -80,  135,  -78,    0,    0,    0,    0,  267,  256,
    0,  270,  130,  238,  142,  137,  128,  159, -180, -180,
   76,   76,   76,   76,  225,  225,  225,   83,   83,    0,
    0,    0,  168,    0,    0,  262,  296, -271,    0,    0,
  260,    0,  192,    0,   71,  268,    0,    0,  265,  227,
    0,  842,    0,  135,    0,    0,    0,  135,    0,   90,
 -264,    0,    0,  307,   71,    0,  260,    0,  278,  265,
  268,    0,  282,    0,    0,    0,    0,    0,   71,   71,
 -271,  281,    0,  271,  266,  287,  324,    0, -296, -243,
    0, -239,    0,  268,    0,    0,    0,    0,   71,  -39,
    0,    0,  330,  329,    0,    0,    0, -107,  -88,    0,
    0,    0,    0,  331,    0, -296, -243,    0,  269, -107,
    0,  269,  330,    0,  269,    0,    0, -243,    0,    0,
    0,
};
final static short yyrindex[] = {                         0,
    0,  911,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    0,   62,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -242,    0,    0,    0,    0,    0,
    0,   30,    0,    0,    0,  305,  146,    0,    0,  303,
 -125,    0,   91,    0,    0,    0,    0,  317,    0,    0,
    0,    0,    0,    0,    0,  -43,    0,    0,    0,    0,
 -242,  -35,    0,    0,    0,  231,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  304,    0,    0,    0,    0,    0,    0,    0,  325,    0,
    0,    0,    0,    0,    0,    0,   94,  752,  731,  703,
  353,  -46,  140,  542,  423,  374,    0,    0,    0,    0,
    0,    0,    0,    0, -231,  -67, -155,  328,    0,    0,
  305,    0, -126,    0,    0,   -4,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  802,    0,
    0,    0,    0,  317,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  203,   66,    0,    0,    0,    0, -220,    0,
    0,   64,  101,    0,    0,    0, -241,    0, -227,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  769,    0,  736,  719,  692,  263,  654,  675,
  570,  591,  612,  633,  472,  493,  521,  395,  444,    0,
    0,    0,    0,    0,    0,    0,  306,    0,    0,    0,
  -86,    0,    0,    0,    0,    0, -187,    0, -218,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  317,
 -214,    0,    0,  322,    0,    0,   65,  264, -238, -199,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -136,   61,    0,  230,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -222, -204,    0,    0,    0, -238,  192,    0,
    0,    0,    0,  299,    0,    0,    0,    0,    0, -238,
    0,    0, -213,    0,    0,    0,    0,    0,    0,    0,
    0,
};
final static short yygindex[] = {                         0,
    5,  549, -157,  -85,    0,   24,    0,    0,    0,  473,
  470,  474,  471,  475,  319,  261,  198,  312,  -79, -166,
    0,  -59,   17,  337,    0,    0,  -83, -206,    0, -146,
  -40,  -71,  359,    0,    0,    0,    0,    4,  566,  567,
    0,    0,  523,    0,    0,    0,  568,    0,    0,    0,
  466,    0,    0,    0,    0,    0,    0,    0,  509,    0,
    0,  408,    0,    0,    0,    0,  528,  597,  610,    0,
  -58,  621,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -53,    0, -192,
    0,    0,    0,    0,    0,  396,    0,
};
final static int YYTABLESIZE=1196;
final static short yytable[] = {                         78,
   44,  137,  259,  161,  208,   12,  216,  157,  158,  253,
   23,  162,  163,  315,  160,   20,  137,  315,  210,  217,
  319,   21,  289,   64,  290,    8,  134,  134,  134,   46,
  147,   27,   27,   18,  212,  245,   49,  212,   41,  151,
  130,  130,  271,  213,  261,  142,  213,  254,   58,  160,
  169,  137,  211,  207,   22,  137,  134,   26,  134,  134,
   26,  134,    3,  260,   51,   27,  134,   67,  202,   27,
   27,   18,   27,  221,    4,    5,  316,  151,  134,  130,
  316,  210,   27,  142,   58,   83,  224,  221,  137,  148,
    7,  130,   65,  159,  318,  285,   26,  212,  134,  212,
  214,   83,   27,  165,  180,   27,  213,  205,  240,  241,
  242,  130,  288,    6,  330,  211,  179,  180,  181,  182,
   26,    6,    7,  153,  191,  327,  251,   82,  293,  165,
  183,  161,   27,  263,  168,  180,  168,  338,  166,   87,
   88,  211,  305,  306,  183,  183,  183,  183,  183,  183,
  183,  183,  183,  183,  183,  183,  183,  183,  183,   45,
  192,  153,  322,  324,  166,  159,  161,   89,   90,  166,
  183,  166,  213,  181,   41,   46,   91,  219,  299,  222,
   54,   92,  287,  277,  286,  283,   56,  219,    6,  183,
  183,  135,  135,  183,   93,   94,   95,   96,   97,   98,
   99,  100,  101,  183,  181,  102,  103,  104,  105,  106,
  107,  108,  220,   73,  220,  262,  222,  264,  320,  295,
  135,  165,  220,  135,  165,  135,   57,  301,    7,  135,
  135,   26,   27,   28,   29,   30,   31,   32,   33,   34,
   35,   36,  135,  334,  174,   73,   68,  174,   70,   73,
  321,  220,  167,  295,  341,  167,  165,   44,   73,   73,
   44,   71,  135,   73,   73,   73,   67,   73,   73,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   46,  167,  337,   46,
  134,  339,   44,   73,  340,   44,   44,   44,   46,   46,
   46,   46,   46,   46,   46,   46,   46,   46,   46,   46,
   46,   46,   46,   46,   46,  313,   44,   44,   83,  171,
   44,   46,  328,  176,  177,   46,   46,  172,   47,   48,
   44,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  333,  188,  189,   46,   46,  183,  190,   46,
   75,  176,  177,   63,  176,  177,   87,   88,   79,   46,
   80,  183,  183,  183,  183,  183,  183,  183,  183,  183,
  183,  183,  183,  183,  183,  183,  183,  184,  185,   15,
  235,  236,  237,   22,   89,   63,   81,  183,  175,   63,
  223,  175,   15,   91,   50,   48,   22,   85,   92,   75,
  134,   87,   88,   66,   48,    6,  183,  183,   63,  140,
  183,   93,   94,   95,   96,   97,   98,   99,  100,   22,
  183,  170,  102,  103,  104,  105,  106,  107,  108,   89,
  164,   75,  145,  145,  173,   75,  145,  176,   91,  231,
  232,  233,  234,   92,   75,   75,   75,   75,  175,   75,
   75,   75,  174,   75,   75,  193,   93,   94,   95,   96,
   97,   98,   99,  100,   22,  177,  178,  102,  103,  104,
  105,  106,  107,  108,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,  145,
  146,  186,  187,   53,   55,  229,  230,  238,  239,  196,
   75,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,  195,  197,  198,    6,
    7,  199,   74,  206,  205,  215,  218,   43,  221,  243,
  249,  250,  252,  207,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  255,   43,  257,  265,  266,
   43,  267,  268,  269,   74,  270,  284,  283,   74,  214,
   43,  113,  278,  299,  113,  113,  291,   74,   74,  113,
  113,  113,   74,   74,   74,  303,   74,   74,  308,  221,
  309,    6,  311,  312,  110,  110,  110,   48,  326,  331,
  110,  110,  110,  221,  158,  178,  113,   56,  336,  113,
  113,  113,  113,  113,  113,  113,  113,   53,  113,  113,
  113,  113,   71,  113,  113,  113,  110,  113,  179,  132,
  110,  110,  110,  110,  110,  110,  110,  110,  219,  110,
  110,  110,  110,   87,  110,  110,  110,  160,  110,  110,
   87,   87,  225,  223,   71,  227,  323,  226,   71,  307,
  228,  149,  150,  151,   88,  194,  244,   71,   71,  210,
  276,   88,   88,   71,   71,   87,   71,   71,  204,   87,
   87,   87,   87,   87,   87,   87,   87,  144,   87,   87,
   87,   87,   83,   87,   87,   87,   88,   87,   87,  143,
   88,   88,   88,   88,   88,   88,   88,   88,  142,   88,
   88,   88,   88,   89,   88,   88,   88,  325,   88,   88,
   89,   89,    0,    0,   83,    0,    0,    0,   83,   83,
   83,   83,   83,   83,   83,   83,    0,   83,   83,   83,
   83,   84,   83,   83,   83,   89,   83,   83,    0,   89,
   89,   89,   89,   89,   89,   89,   89,    0,   89,   89,
   89,   89,   86,   89,   89,   89,    0,   89,   89,    0,
    0,    0,    0,   84,    0,    0,    0,   84,   84,   84,
   84,   84,   84,   84,   84,    0,   84,   84,   84,   84,
   85,   84,   84,   84,   86,   84,   84,    0,   86,   86,
   86,   86,   86,   86,   86,   86,    0,   86,   86,   86,
   86,   78,   86,   86,   86,    0,   86,   86,    0,    0,
    0,    0,   85,    0,    0,    0,   85,   85,   85,   85,
   85,   85,   85,   85,    0,   85,   85,   85,   85,   81,
   85,   85,   85,   78,   85,   85,    0,   78,   78,   78,
   78,   78,    0,    0,    0,    0,   78,   78,   78,   78,
   82,   78,   78,   78,    0,   78,   78,    0,    0,    0,
    0,   81,    0,    0,    0,   81,   81,   81,   81,   81,
    0,   79,    0,    0,   81,   81,   81,   81,    0,   81,
   81,   81,   82,   81,   81,    0,   82,   82,   82,   82,
   82,    0,   80,    0,    0,   82,   82,   82,   82,    0,
   82,   82,   82,   79,   82,   82,    0,   79,   79,   79,
   79,   79,    0,   76,    0,    0,   79,   79,   79,   79,
    0,   79,   79,   79,   80,   79,   79,    0,   80,   80,
   80,   80,   80,    0,   77,    0,    0,   80,   80,   80,
   80,    0,   80,   80,   80,   76,   80,   80,    0,   76,
    0,   72,    0,    0,    0,    0,    0,    0,   76,   76,
   76,   76,   69,   76,   76,   76,   77,   76,   76,    0,
   77,    0,    0,    0,    0,    0,    0,    0,   70,   77,
   77,   77,   77,   72,   77,   77,   77,   72,   77,   77,
   67,    0,    0,    0,   69,   68,   72,   72,   69,    0,
    0,    0,   72,   72,    0,   72,   72,   69,   69,    0,
   70,   65,    0,   69,   70,    0,   69,   69,    0,    0,
    0,    0,   67,   70,   70,    0,   67,   68,   66,   70,
    0,   68,   70,   70,    0,   67,   67,    0,    0,    0,
   68,   68,    0,   65,   67,   67,    0,   65,    0,   68,
   68,    0,    0,    0,    0,    0,    0,   65,    0,    0,
   66,    0,  110,  110,   66,   65,   65,  110,  110,  110,
    0,    0,    0,    0,   66,    0,    0,    0,    0,    0,
    0,    0,   66,   66,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  110,  110,
  110,  110,  110,  110,  110,    0,  110,  110,  110,  110,
    0,  110,  110,  110,    0,  110,   26,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   40,    0,    0,    0,    0,    0,   89,    0,    0,    0,
    0,    0,    0,    0,    0,   91,    0,    0,    0,    0,
   92,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    6,    7,   93,   94,   95,   96,   97,   98,   99,
  100,   22,    0,    0,  102,  103,  104,  105,  106,  107,
  108,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,
};
final static short yycheck[] = {                         58,
    0,   73,  209,   89,  151,    2,  164,   87,   88,  260,
    6,   91,   92,  257,  257,  274,  258,  257,  257,  282,
  260,    5,  287,  261,  289,    2,  258,  259,  260,    0,
  257,  259,  260,  330,  257,  193,   20,  260,   15,  260,
  259,  260,  314,  257,  211,  260,  260,  298,   45,  292,
  110,  293,  257,  295,  330,  297,  288,  257,  330,  291,
  260,  293,  257,  210,  258,  293,  298,  330,  140,  257,
  298,  330,  260,  316,  269,  270,  320,  298,  310,  298,
  320,  320,  310,  298,   81,   62,  172,  330,  330,   86,
  317,  310,  330,   89,  301,  262,  296,  320,  330,  159,
  160,   78,  330,  258,  260,  293,  320,  295,  188,  189,
  190,  330,  270,  316,  321,  320,  297,  298,  299,  300,
  320,  316,  317,  260,  260,  318,  198,  330,  275,  258,
  257,  257,  320,  213,  258,  291,  258,  330,  293,  267,
  268,  296,  289,  290,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  291,
  296,  298,  309,  310,  293,  292,  292,  295,  296,  293,
  297,  293,  296,  260,  151,  291,  304,  258,  286,  258,
  332,  309,  268,  255,  264,  293,  330,  258,  316,  316,
  317,  259,  260,  320,  322,  323,  324,  325,  326,  327,
  328,  329,  330,  330,  291,  333,  334,  335,  336,  337,
  338,  339,  293,  260,  293,  296,  258,  296,  302,  278,
  288,  257,  293,  291,  260,  293,  330,  281,  317,  297,
  298,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  310,  327,  288,  292,  295,  291,  318,  296,
  304,  293,  257,  312,  338,  260,  292,  257,  305,  306,
  260,  331,  330,  310,  311,  312,  330,  314,  315,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  257,  292,  329,  260,
  330,  332,  292,  288,  335,  295,  296,  297,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  299,  316,  317,  295,  306,
  320,  292,  319,  260,  260,  296,  297,  314,  257,  258,
  330,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  326,  261,  262,  316,  317,  257,  266,  320,
  297,  288,  288,  260,  291,  291,  267,  268,  292,  330,
  257,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  301,  302,  303,  318,
  183,  184,  185,  318,  295,  292,  260,  297,  288,  296,
  330,  291,  331,  304,  257,  258,  331,  292,  309,  260,
  330,  267,  268,  257,  258,  316,  316,  317,  315,  287,
  320,  322,  323,  324,  325,  326,  327,  328,  329,  330,
  330,  296,  333,  334,  335,  336,  337,  338,  339,  295,
  263,  292,  287,  288,  305,  296,  291,  310,  304,  179,
  180,  181,  182,  309,  305,  306,  307,  308,  312,  310,
  311,  312,  311,  314,  315,  291,  322,  323,  324,  325,
  326,  327,  328,  329,  330,  307,  308,  333,  334,  335,
  336,  337,  338,  339,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  284,  285,  320,
  321,  267,  268,  291,  292,  177,  178,  186,  187,  258,
  297,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  297,  258,  260,  316,
  317,  330,  260,  320,  320,  296,  294,  297,  282,  330,
  330,  330,  287,  330,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  260,  316,  330,  282,  294,
  320,  282,  315,  292,  292,  260,  330,  293,  296,  296,
  330,  258,  295,  286,  261,  262,  260,  305,  306,  266,
  267,  268,  310,  311,  312,  294,  314,  315,  298,  316,
  310,  316,  296,  260,  260,  261,  262,  258,  260,  259,
  266,  267,  268,  330,  292,  291,  293,  292,  330,  296,
  297,  298,  299,  300,  301,  302,  303,  291,  305,  306,
  307,  308,  260,  310,  311,  312,  292,  314,  291,  298,
  296,  297,  298,  299,  300,  301,  302,  303,  330,  305,
  306,  307,  308,  260,  310,  311,  312,   89,  314,  315,
  267,  268,  173,  171,  292,  175,  310,  174,  296,  291,
  176,   86,   86,   86,  260,  133,  191,  305,  306,  151,
  253,  267,  268,  311,  312,  292,  314,  315,  141,  296,
  297,  298,  299,  300,  301,  302,  303,   81,  305,  306,
  307,  308,  260,  310,  311,  312,  292,  314,  315,   80,
  296,  297,  298,  299,  300,  301,  302,  303,   78,  305,
  306,  307,  308,  260,  310,  311,  312,  312,  314,  315,
  267,  268,   -1,   -1,  292,   -1,   -1,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,   -1,  305,  306,  307,
  308,  260,  310,  311,  312,  292,  314,  315,   -1,  296,
  297,  298,  299,  300,  301,  302,  303,   -1,  305,  306,
  307,  308,  260,  310,  311,  312,   -1,  314,  315,   -1,
   -1,   -1,   -1,  292,   -1,   -1,   -1,  296,  297,  298,
  299,  300,  301,  302,  303,   -1,  305,  306,  307,  308,
  260,  310,  311,  312,  292,  314,  315,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,   -1,  305,  306,  307,
  308,  260,  310,  311,  312,   -1,  314,  315,   -1,   -1,
   -1,   -1,  292,   -1,   -1,   -1,  296,  297,  298,  299,
  300,  301,  302,  303,   -1,  305,  306,  307,  308,  260,
  310,  311,  312,  292,  314,  315,   -1,  296,  297,  298,
  299,  300,   -1,   -1,   -1,   -1,  305,  306,  307,  308,
  260,  310,  311,  312,   -1,  314,  315,   -1,   -1,   -1,
   -1,  292,   -1,   -1,   -1,  296,  297,  298,  299,  300,
   -1,  260,   -1,   -1,  305,  306,  307,  308,   -1,  310,
  311,  312,  292,  314,  315,   -1,  296,  297,  298,  299,
  300,   -1,  260,   -1,   -1,  305,  306,  307,  308,   -1,
  310,  311,  312,  292,  314,  315,   -1,  296,  297,  298,
  299,  300,   -1,  260,   -1,   -1,  305,  306,  307,  308,
   -1,  310,  311,  312,  292,  314,  315,   -1,  296,  297,
  298,  299,  300,   -1,  260,   -1,   -1,  305,  306,  307,
  308,   -1,  310,  311,  312,  292,  314,  315,   -1,  296,
   -1,  260,   -1,   -1,   -1,   -1,   -1,   -1,  305,  306,
  307,  308,  260,  310,  311,  312,  292,  314,  315,   -1,
  296,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  260,  305,
  306,  307,  308,  292,  310,  311,  312,  296,  314,  315,
  260,   -1,   -1,   -1,  292,  260,  305,  306,  296,   -1,
   -1,   -1,  311,  312,   -1,  314,  315,  305,  306,   -1,
  292,  260,   -1,  311,  296,   -1,  314,  315,   -1,   -1,
   -1,   -1,  292,  305,  306,   -1,  296,  292,  260,  311,
   -1,  296,  314,  315,   -1,  305,  306,   -1,   -1,   -1,
  305,  306,   -1,  292,  314,  315,   -1,  296,   -1,  314,
  315,   -1,   -1,   -1,   -1,   -1,   -1,  306,   -1,   -1,
  292,   -1,  261,  262,  296,  314,  315,  266,  267,  268,
   -1,   -1,   -1,   -1,  306,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  314,  315,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  297,  298,
  299,  300,  301,  302,  303,   -1,  305,  306,  307,  308,
   -1,  310,  311,  312,   -1,  314,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,   -1,   -1,   -1,   -1,   -1,  295,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  304,   -1,   -1,   -1,   -1,
  309,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  316,  317,  322,  323,  324,  325,  326,  327,  328,
  329,  330,   -1,   -1,  333,  334,  335,  336,  337,  338,
  339,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,
};
final static short YYFINAL=1;
final static short YYMAXTOKEN=339;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","DOTDOTDOT","COMMA","STAR","PERCENT","EQUALS",
"ANNOSTRING","ANNOCHAR","SLASH","PLUS","MINUS","PACKAGE","IMPORT","PUBLIC",
"PROTECTED","PRIVATE","STATIC","FINAL","ABSTRACT","NATIVE","STRICTFP",
"SYNCHRONIZED","TRANSIENT","VOLATILE","CLASS","INTERFACE","ENUM",
"ANNOINTERFACE","THROWS","EXTENDS","IMPLEMENTS","SUPER","DEFAULT","BRACEOPEN",
"BRACECLOSE","SQUAREOPEN","SQUARECLOSE","PARENOPEN","PARENCLOSE","LESSTHAN",
"GREATERTHAN","LESSEQUALS","GREATEREQUALS","LESSTHAN2","GREATERTHAN2",
"GREATERTHAN3","EXCLAMATION","AMPERSAND2","VERTLINE2","EQUALS2","NOTEQUALS",
"TILDE","AMPERSAND","VERTLINE","CIRCUMFLEX","VOID","QUERY","COLON","AT",
"JAVADOCSTART","JAVADOCEND","JAVADOCEOL","CODEBLOCK","PARENBLOCK","BYTE",
"SHORT","INT","LONG","CHAR","FLOAT","DOUBLE","BOOLEAN","IDENTIFIER",
"JAVADOCTAG","JAVADOCLINE","BOOLEAN_LITERAL","INTEGER_LITERAL","LONG_LITERAL",
"FLOAT_LITERAL","DOUBLE_LITERAL","CHAR_LITERAL","STRING_LITERAL",
};
final static String yyrule[] = {
"$accept : file",
"file :",
"$$1 :",
"file : file $$1 filepart",
"filepart : annotation",
"filepart : package",
"filepart : import",
"filepart : javadoc",
"filepart : class",
"filepart : enum",
"filepart : SEMI",
"package : PACKAGE fullidentifier SEMI",
"import : IMPORT fullidentifier SEMI",
"import : IMPORT STATIC fullidentifier SEMI",
"javadoc : JAVADOCSTART javadocdescription javadoctags JAVADOCEND",
"javadocdescription : javadoctokens",
"javadoctokens :",
"javadoctokens : javadoctokens javadoctoken",
"javadoctoken : JAVADOCLINE",
"javadoctags :",
"javadoctags : javadoctags javadoctag",
"$$2 :",
"javadoctag : JAVADOCTAG $$2 javadoctokens",
"fullidentifier : IDENTIFIER",
"fullidentifier : fullidentifier DOT IDENTIFIER",
"fullidentifier : fullidentifier DOT STAR",
"arrayidentifier : IDENTIFIER dimensions",
"dimensions :",
"dimensions : dimensions SQUAREOPEN SQUARECLOSE",
"modifier : PUBLIC",
"modifier : PROTECTED",
"modifier : PRIVATE",
"modifier : STATIC",
"modifier : FINAL",
"modifier : ABSTRACT",
"modifier : NATIVE",
"modifier : SYNCHRONIZED",
"modifier : VOLATILE",
"modifier : TRANSIENT",
"modifier : STRICTFP",
"modifiers : modifiers modifier",
"modifiers : modifiers annotation",
"modifiers : modifiers javadoc",
"modifiers :",
"$$3 :",
"annotation : AT name $$3 annotationParensOpt",
"annotationParensOpt :",
"annotationParensOpt : PARENOPEN value PARENCLOSE",
"annotationParensOpt : PARENOPEN valuePairs PARENCLOSE",
"annotationParensOpt : PARENOPEN PARENCLOSE",
"valuePairs : valuePair",
"valuePairs : valuePairs COMMA valuePair",
"valuePair : IDENTIFIER EQUALS value",
"$$4 :",
"arrayInitializer : $$4 BRACEOPEN valuesOpt BRACECLOSE",
"valuesOpt :",
"valuesOpt : values",
"values : value",
"values : values COMMA value",
"value : expression",
"value : annotation",
"value : arrayInitializer",
"expression : conditionalExpression",
"conditionalExpression : conditionalOrExpression",
"conditionalExpression : conditionalOrExpression QUERY expression COLON expression",
"conditionalOrExpression : conditionalAndExpression",
"conditionalOrExpression : conditionalOrExpression VERTLINE2 conditionalAndExpression",
"conditionalAndExpression : inclusiveOrExpression",
"conditionalAndExpression : conditionalAndExpression AMPERSAND2 inclusiveOrExpression",
"inclusiveOrExpression : exclusiveOrExpression",
"inclusiveOrExpression : inclusiveOrExpression VERTLINE exclusiveOrExpression",
"exclusiveOrExpression : andExpression",
"exclusiveOrExpression : exclusiveOrExpression CIRCUMFLEX andExpression",
"andExpression : equalityExpression",
"andExpression : andExpression AMPERSAND equalityExpression",
"equalityExpression : relationalExpression",
"equalityExpression : equalityExpression EQUALS2 relationalExpression",
"equalityExpression : equalityExpression NOTEQUALS relationalExpression",
"relationalExpression : shiftExpression",
"relationalExpression : relationalExpression LESSEQUALS shiftExpression",
"relationalExpression : relationalExpression GREATEREQUALS shiftExpression",
"relationalExpression : relationalExpression LESSTHAN shiftExpression",
"relationalExpression : relationalExpression GREATERTHAN shiftExpression",
"shiftExpression : additiveExpression",
"shiftExpression : shiftExpression LESSTHAN2 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN3 additiveExpression",
"shiftExpression : shiftExpression GREATERTHAN2 additiveExpression",
"additiveExpression : multiplicativeExpression",
"additiveExpression : additiveExpression PLUS multiplicativeExpression",
"additiveExpression : additiveExpression MINUS multiplicativeExpression",
"multiplicativeExpression : unaryExpression",
"multiplicativeExpression : multiplicativeExpression STAR unaryExpression",
"multiplicativeExpression : multiplicativeExpression SLASH unaryExpression",
"multiplicativeExpression : multiplicativeExpression PERCENT unaryExpression",
"unaryExpression : PLUS unaryExpression",
"unaryExpression : MINUS unaryExpression",
"unaryExpression : unaryExpressionNotPlusMinus",
"unaryExpressionNotPlusMinus : TILDE unaryExpression",
"unaryExpressionNotPlusMinus : EXCLAMATION unaryExpression",
"unaryExpressionNotPlusMinus : primary",
"primary : PARENOPEN primitiveType PARENCLOSE unaryExpression",
"primary : PARENOPEN primitiveType dims PARENCLOSE unaryExpression",
"primary : PARENOPEN name dims PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN name PARENCLOSE unaryExpressionNotPlusMinus",
"primary : PARENOPEN expression PARENCLOSE",
"primary : literal",
"primary : primitiveType dims DOT CLASS",
"primary : primitiveType DOT CLASS",
"primary : name DOT CLASS",
"primary : name dims DOT CLASS",
"primary : name",
"dims : SQUAREOPEN SQUARECLOSE",
"dims : dims SQUAREOPEN SQUARECLOSE",
"name : IDENTIFIER",
"name : name DOT IDENTIFIER",
"literal : DOUBLE_LITERAL",
"literal : FLOAT_LITERAL",
"literal : LONG_LITERAL",
"literal : INTEGER_LITERAL",
"literal : BOOLEAN_LITERAL",
"literal : CHAR_LITERAL",
"literal : STRING_LITERAL",
"primitiveType : BOOLEAN",
"primitiveType : BYTE",
"primitiveType : SHORT",
"primitiveType : INT",
"primitiveType : LONG",
"primitiveType : CHAR",
"primitiveType : FLOAT",
"primitiveType : DOUBLE",
"type : classtype dimensions",
"$$5 :",
"$$6 :",
"classtype : typedeclspecifier LESSTHAN $$5 typearglist $$6 GREATERTHAN",
"classtype : typedeclspecifier",
"typedeclspecifier : typename",
"typedeclspecifier : classtype DOT IDENTIFIER",
"typename : IDENTIFIER",
"typename : typename DOT IDENTIFIER",
"typearglist : typearg",
"typearglist : typearglist COMMA typearg",
"typearg : type",
"typearg : QUERY",
"typearg : QUERY EXTENDS type",
"typearg : QUERY SUPER type",
"opt_typeparams :",
"opt_typeparams : typeparams",
"$$7 :",
"typeparams : LESSTHAN $$7 typeparamlist GREATERTHAN",
"typeparamlist : typeparam",
"typeparamlist : typeparamlist COMMA typeparam",
"typeparam : IDENTIFIER",
"$$8 :",
"typeparam : IDENTIFIER EXTENDS $$8 typeboundlist",
"typeboundlist : type",
"typeboundlist : typeboundlist AMPERSAND type",
"enum : enum_definition BRACEOPEN enum_body BRACECLOSE",
"enum_definition : modifiers ENUM IDENTIFIER opt_implements",
"enum_body : enum_values",
"enum_body : enum_values SEMI members",
"enum_values :",
"enum_values : enum_value",
"enum_values : enum_value COMMA enum_values",
"enum_value : javadoc opt_annotations enum_constructor",
"enum_value : opt_annotations enum_constructor",
"enum_constructor : IDENTIFIER",
"enum_constructor : IDENTIFIER CODEBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK",
"enum_constructor : IDENTIFIER PARENBLOCK CODEBLOCK",
"class : classdefinition BRACEOPEN members BRACECLOSE",
"classdefinition : modifiers classorinterface IDENTIFIER opt_typeparams opt_extends opt_implements",
"classorinterface : CLASS",
"classorinterface : INTERFACE",
"classorinterface : ANNOINTERFACE",
"opt_extends :",
"opt_extends : EXTENDS extendslist",
"extendslist : classtype",
"extendslist : extendslist COMMA classtype",
"opt_implements :",
"opt_implements : IMPLEMENTS implementslist",
"implementslist : classtype",
"implementslist : implementslist COMMA classtype",
"members :",
"$$9 :",
"members : members $$9 member",
"member : javadoc",
"member : fields",
"member : method",
"member : constructor",
"member : static_block",
"member : class",
"member : enum",
"member : SEMI",
"memberend : SEMI",
"memberend : CODEBLOCK",
"static_block : modifiers CODEBLOCK",
"$$10 :",
"fields : modifiers type arrayidentifier $$10 extrafields memberend",
"extrafields :",
"$$11 :",
"extrafields : extrafields COMMA $$11 arrayidentifier",
"$$12 :",
"extrafields : extrafields COMMA javadoc $$12 arrayidentifier",
"$$13 :",
"method : modifiers typeparams type IDENTIFIER $$13 methoddef dimensions opt_exceptions memberend",
"$$14 :",
"method : modifiers type IDENTIFIER $$14 methoddef dimensions opt_exceptions memberend",
"$$15 :",
"constructor : modifiers IDENTIFIER $$15 methoddef opt_exceptions memberend",
"methoddef : PARENOPEN opt_params PARENCLOSE",
"opt_exceptions :",
"opt_exceptions : THROWS exceptionlist",
"exceptionlist : fullidentifier",
"exceptionlist : exceptionlist COMMA fullidentifier",
"opt_params :",
"opt_params : paramlist",
"paramlist : param",
"paramlist : paramlist COMMA param",
"param : opt_annotations opt_parammodifiers type varargs arrayidentifier",
"varargs :",
"varargs : DOTDOTDOT",
"opt_annotations :",
"opt_annotations : opt_annotations annotation",
"opt_parammodifiers :",
"opt_parammodifiers : opt_parammodifiers modifier",
};

//#line 540 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"

private Lexer lexer;
private Builder builder;
private StringBuffer textBuffer = new StringBuffer();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private List annotationStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized 
private Annotation annotation = null;
private List annoValueListStack = new ArrayList(); // Use ArrayList intead of Stack because it is unsynchronized
private List annoValueList = null;
private FieldDef param = new FieldDef();
private java.util.Set modifiers = new java.util.HashSet();
private TypeDef fieldType;
private TypeVariableDef typeVariable;
private Stack typeStack = new Stack();
private int line;
private int column;
private boolean debugLexer;

private void appendToBuffer(String word) {
    if (textBuffer.length() > 0) {
        char lastChar = textBuffer.charAt(textBuffer.length() - 1);
        if (!Character.isWhitespace(lastChar)) {
            textBuffer.append(' ');
        }
    }
    textBuffer.append(word);
}

private String buffer() {
    String result = textBuffer.toString().trim();
    textBuffer.setLength(0);
    return result;
}

public Parser(Lexer lexer, Builder builder) {
    this.lexer = lexer;
    this.builder = builder;
}

public void setDebugParser(boolean debug) {
    yydebug = debug;
}

public void setDebugLexer(boolean debug) {
    debugLexer = debug;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        if (debugLexer) {
            System.err.println("Token: " + yyname[result] + " \"" + yylval.sval + "\"");
        }
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
	Object oval;
    String sval;
    int ival;
	boolean bval;
    TypeDef type;
    AnnotationValue annoval;
}


private void makeField(TypeDef field, String body) {
    FieldDef fd = new FieldDef();
    fd.lineNumber = line;
    fd.modifiers.addAll(modifiers); 
    fd.name = field.name;
    fd.type = fieldType;
    fd.dimensions = field.dimensions;
    fd.body = body;
    builder.addField(fd);
}

private String convertString(String str) {
	StringBuffer buf = new StringBuffer();
	boolean escaped = false;
	int unicode = 0;
	int value = 0;
	int octal = 0;
	boolean consumed = false;
	
	for(int i = 0; i < str.length(); ++ i) {
		char ch = str.charAt( i );
		
		if(octal > 0) {
			if( value >= '0' && value <= '7' ) {
				value = ( value << 3 ) | Character.digit( ch, 8 );
				-- octal;
				consumed = true;
			}
			else {
				octal = 0;
			}
			
			if( octal == 0 ) {
				buf.append( (char) value );		
				value = 0;
			}
		}
		
		if(!consumed) {
			if(unicode > 0) {
				value = ( value << 4 ) | Character.digit( ch, 16 );
				
				-- unicode;
		
				if(unicode == 0) {
					buf.append( (char)value );
					value = 0;
				}
			}
			else if(ch == '\\') {
				escaped = true;
			}
			else if(escaped) {
				if(ch == 'u' || ch == 'U') {
					unicode = 4;
				}
				else if(ch >= '0' && ch <= '7') {
					octal = (ch > '3') ? 1 : 2;
					value = Character.digit( ch, 8 );
				}
				else {
					switch( ch ) {
						case 'b':
							buf.append('\b');
							break;
							
						case 'f':
							buf.append('\f');
							break;
							
						case 'n':
							buf.append('\n');
							break;
							
						case 'r':
							buf.append('\r');
							break;
							
						case 't':
							buf.append('\t');
							break;
							
						case '\'':
							buf.append('\'');
							break;
	
						case '\"':
							buf.append('\"');
							break;
	
						case '\\':
							buf.append('\\');
							break;
							
						default:
							yyerror( "Illegal escape character '" + ch + "'" );
					}
				}
				
				escaped = false;
			}
			else {
				buf.append( ch );
			}
		}
	}

	return buf.toString();
}

private Boolean toBoolean(String str) {
	str = str.trim();

	return new Boolean( str );
}

private Integer toInteger(String str) {
	str = str.trim();
	
	Integer result;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Integer( Integer.parseInt( str.substring( 2 ), 16 ) );
	}
	else if(str.length() > 1 && str.startsWith("0") ) {
		result = new Integer( Integer.parseInt( str.substring( 1 ), 8 ) );
	}
	else {
		result = new Integer( str );
	}
	
	return result;
}

private Long toLong(String str) {
	str = str.trim();

	Long result;
	
	if( !str.endsWith("l") && !str.endsWith("L") ) {
		yyerror( "Long literal must end with 'l' or 'L'." );
	}
	
	int len = str.length() - 1;
	
	if(str.startsWith("0x") || str.startsWith( "0X" ) ) {
		result = new Long( Long.parseLong( str.substring( 2, len ), 16 ) );
	}
	else if(str.startsWith("0") ) {
		result = new Long( Long.parseLong( str.substring( 1, len ), 8 ) );
	}
	else {
		result = new Long( str.substring( 0, len ) );
	}

	return result;
}

private Float toFloat(String str) {
	str = str.trim();
	return new Float( str );
}

private Double toDouble(String str) {
	str = str.trim();

	if( !str.endsWith("d") && !str.endsWith("D") ) {
		yyerror( "Double literal must end with 'd' or 'D'." );
	}
	
	return new Double( str.substring( 0, str.length() - 1 ) );
}

/**
 * Convert a character literal into a character.
 */
private Character toChar(String str) {
	str = str.trim();

	if( !str.startsWith("'") && !str.endsWith("'") ) {
		yyerror("Character must be single quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	
	if( str2.length() != 1) {
		yyerror("Only one character allowed in character constants.");
	}
	
	return new Character( str2.charAt( 0 ) );
}

/**
 * Convert a string literal into a string.
 */
private String toString(String str) {
	str = str.trim();

	if( str.length() < 2 && !str.startsWith("\"") && !str.endsWith("\"") ) {
		yyerror("String must be double quoted.");
	}

	String str2 = convertString( str.substring( 1, str.length() - 1 ) );
	return str2;
}
//#line 1179 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 2:
//#line 56 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 4:
//#line 59 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 11:
//#line 62 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addPackage(new PackageDef(val_peek(1).sval, line)); }
break;
case 12:
//#line 65 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 13:
//#line 66 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addImport(val_peek(1).sval); }
break;
case 15:
//#line 74 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
        builder.addJavaDoc(buffer()); 
    }
break;
case 18:
//#line 81 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        appendToBuffer(val_peek(0).sval);
    }
break;
case 21:
//#line 88 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 22:
//#line 89 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        builder.addJavaDocTag(new TagDef(val_peek(2).sval.substring(1), buffer(), line)); 
    }
break;
case 23:
//#line 98 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 24:
//#line 99 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 25:
//#line 100 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + ".*"; }
break;
case 26:
//#line 103 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival);
    }
break;
case 27:
//#line 108 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.ival = 0; }
break;
case 28:
//#line 109 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        yyval.ival = val_peek(2).ival + 1; 
    }
break;
case 29:
//#line 115 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "public"; }
break;
case 30:
//#line 116 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "protected"; }
break;
case 31:
//#line 117 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "private"; }
break;
case 32:
//#line 118 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "static"; }
break;
case 33:
//#line 119 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "final"; }
break;
case 34:
//#line 120 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "abstract"; }
break;
case 35:
//#line 121 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "native"; }
break;
case 36:
//#line 122 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "synchronized"; }
break;
case 37:
//#line 123 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "volatile"; }
break;
case 38:
//#line 124 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "transient"; }
break;
case 39:
//#line 125 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "strictfp"; }
break;
case 40:
//#line 128 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ modifiers.add(val_peek(0).sval); }
break;
case 41:
//#line 129 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 44:
//#line 140 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
    	annotationStack.add(annotation);
    	annotation = new Annotation(builder.createType(val_peek(0).sval, 0), lexer.getLine()); 
    }
break;
case 45:
//#line 145 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	yyval.annoval = annotation;
    	annotation = (Annotation)annotationStack.remove(annotationStack.size() - 1);
    }
break;
case 47:
//#line 152 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annotation.setProperty("value", val_peek(1).annoval); }
break;
case 52:
//#line 161 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annotation.setProperty(val_peek(2).sval, val_peek(0).annoval); }
break;
case 53:
//#line 164 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	annoValueListStack.add(annoValueList);
    	annoValueList = new ArrayList(); 
    }
break;
case 54:
//#line 169 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	yyval.annoval = new AnnotationValueList(annoValueList);
    	annoValueList = (List)annoValueListStack.remove(annoValueListStack.size() - 1);
    }
break;
case 57:
//#line 179 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 58:
//#line 180 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ annoValueList.add(val_peek(0).annoval); }
break;
case 59:
//#line 183 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 60:
//#line 184 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 61:
//#line 185 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 62:
//#line 188 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 63:
//#line 191 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 64:
//#line 192 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationQuery(val_peek(4).annoval, val_peek(2).annoval, val_peek(0).annoval); }
break;
case 65:
//#line 195 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 66:
//#line 196 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 67:
//#line 199 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 68:
//#line 200 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 69:
//#line 203 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 70:
//#line 204 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 71:
//#line 207 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 72:
//#line 208 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationExclusiveOr(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 73:
//#line 211 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 74:
//#line 212 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAnd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 75:
//#line 215 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 76:
//#line 216 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 77:
//#line 217 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNotEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 78:
//#line 220 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 79:
//#line 221 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 80:
//#line 222 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterEquals(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 81:
//#line 223 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLessThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 82:
//#line 224 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationGreaterThan(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 83:
//#line 227 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 84:
//#line 228 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftLeft(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 85:
//#line 229 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationUnsignedShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 86:
//#line 230 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationShiftRight(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 87:
//#line 233 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 88:
//#line 234 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationAdd(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 89:
//#line 235 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationSubtract(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 90:
//#line 238 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 91:
//#line 239 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMultiply(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 92:
//#line 240 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationDivide(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 93:
//#line 241 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationRemainder(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 94:
//#line 244 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationPlusSign(val_peek(0).annoval); }
break;
case 95:
//#line 245 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationMinusSign(val_peek(0).annoval); }
break;
case 96:
//#line 246 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 97:
//#line 249 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationNot(val_peek(0).annoval); }
break;
case 98:
//#line 250 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationLogicalNot(val_peek(0).annoval); }
break;
case 100:
//#line 254 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 101:
//#line 255 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 102:
//#line 256 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 103:
//#line 257 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationCast(builder.createType(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 104:
//#line 258 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationParenExpression(val_peek(1).annoval); }
break;
case 105:
//#line 259 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = val_peek(0).annoval; }
break;
case 106:
//#line 260 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 107:
//#line 261 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 108:
//#line 262 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(2).sval, 0)); }
break;
case 109:
//#line 263 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationTypeRef(builder.createType(val_peek(3).sval, 0)); }
break;
case 110:
//#line 264 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationFieldRef(val_peek(0).sval); }
break;
case 111:
//#line 267 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.ival = 1; }
break;
case 112:
//#line 268 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.ival = val_peek(2).ival + 1; }
break;
case 113:
//#line 271 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 114:
//#line 272 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + "." + val_peek(0).sval; }
break;
case 115:
//#line 275 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toDouble(val_peek(0).sval), val_peek(0).sval); }
break;
case 116:
//#line 276 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toFloat(val_peek(0).sval), val_peek(0).sval); }
break;
case 117:
//#line 277 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toLong(val_peek(0).sval), val_peek(0).sval); }
break;
case 118:
//#line 278 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toInteger(val_peek(0).sval), val_peek(0).sval); }
break;
case 119:
//#line 279 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AnnotationConstant(toBoolean(val_peek(0).sval), val_peek(0).sval); }
break;
case 120:
//#line 280 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toChar(s), s); }
break;
case 121:
//#line 281 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ String s = lexer.getCodeBody(); yyval.annoval = new AnnotationConstant(toString(s), s); }
break;
case 122:
//#line 284 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "boolean"; }
break;
case 123:
//#line 285 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "byte"; }
break;
case 124:
//#line 286 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "short"; }
break;
case 125:
//#line 287 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "int"; }
break;
case 126:
//#line 288 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "long"; }
break;
case 127:
//#line 289 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "char"; }
break;
case 128:
//#line 290 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "float"; }
break;
case 129:
//#line 291 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = "double"; }
break;
case 130:
//#line 297 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    	TypeDef td = val_peek(1).type;
    	td.dimensions = val_peek(0).ival;
        yyval.type = td;
    }
break;
case 131:
//#line 304 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    		TypeDef td = new TypeDef(val_peek(1).sval,0);
    		td.actualArgumentTypes = new ArrayList();
    		yyval.type = (TypeDef) typeStack.push(td);
    	}
break;
case 132:
//#line 308 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
    		yyval.type = (TypeDef) typeStack.pop();
    	}
break;
case 133:
//#line 310 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
         yyval.type = val_peek(1).type;
    }
break;
case 134:
//#line 313 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        yyval.type = new TypeDef(val_peek(0).sval,0); 
    }
break;
case 135:
//#line 318 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 136:
//#line 319 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).type.name + '.' + val_peek(0).sval; }
break;
case 137:
//#line 322 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(0).sval; }
break;
case 138:
//#line 323 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval; }
break;
case 139:
//#line 326 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 140:
//#line 327 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ ((TypeDef) typeStack.peek()).actualArgumentTypes.add(val_peek(0).type);}
break;
case 141:
//#line 330 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = val_peek(0).type;}
break;
case 142:
//#line 331 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef();}
break;
case 143:
//#line 332 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "extends");}
break;
case 144:
//#line 333 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.type = new WildcardTypeDef(val_peek(0).type, "super");}
break;
case 147:
//#line 337 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ mth.typeParams = new ArrayList(); }
break;
case 151:
//#line 344 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ mth.typeParams.add(new TypeVariableDef(val_peek(0).sval)); }
break;
case 152:
//#line 345 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ 
      typeVariable = new TypeVariableDef(val_peek(1).sval);
      typeVariable.bounds = new ArrayList();
    }
break;
case 153:
//#line 348 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      mth.typeParams.add(typeVariable);
      typeVariable = null;
    }
break;
case 154:
//#line 354 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ typeVariable.bounds.add(val_peek(0).type); }
break;
case 155:
//#line 355 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ typeVariable.bounds.add(val_peek(0).type); }
break;
case 156:
//#line 359 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
  builder.endClass();
  fieldType = null;
  modifiers.clear();
}
break;
case 157:
//#line 365 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
    cls.lineNumber = line;
    cls.modifiers.addAll(modifiers);
    cls.name = val_peek(1).sval;
    cls.type = ClassDef.ENUM;
    builder.beginClass(cls);
    cls = new ClassDef();
    fieldType = new TypeDef(val_peek(1).sval, 0);
}
break;
case 165:
//#line 384 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(0).sval, 0), ""); }
break;
case 166:
//#line 385 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 167:
//#line 386 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(1).sval, 0), ""); }
break;
case 168:
//#line 387 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ makeField(new TypeDef(val_peek(2).sval, 0), ""); }
break;
case 169:
//#line 393 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        builder.endClass(); 
    }
break;
case 170:
//#line 398 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        cls.lineNumber = line;
        cls.modifiers.addAll(modifiers); modifiers.clear(); 
        cls.name = val_peek(3).sval;
        builder.beginClass(cls); 
        cls = new ClassDef(); 
    }
break;
case 171:
//#line 407 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.type = ClassDef.CLASS; }
break;
case 172:
//#line 408 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.type = ClassDef.INTERFACE; }
break;
case 173:
//#line 409 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.type = ClassDef.ANNOTATION_TYPE; }
break;
case 176:
//#line 414 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 177:
//#line 415 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.extendz.add(val_peek(0).type); }
break;
case 180:
//#line 420 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 181:
//#line 421 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ cls.implementz.add(val_peek(0).type); }
break;
case 183:
//#line 423 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 193:
//#line 436 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      yyval.sval = "";
    }
break;
case 194:
//#line 439 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
	  yyval.sval = lexer.getCodeBody();
    }
break;
case 195:
//#line 444 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ lexer.getCodeBody(); modifiers.clear(); }
break;
case 196:
//#line 449 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        fieldType = val_peek(1).type;
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 197:
//#line 453 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        modifiers.clear();
    }
break;
case 199:
//#line 458 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 200:
//#line 458 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 201:
//#line 461 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ line = lexer.getLine(); }
break;
case 202:
//#line 461 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        makeField(val_peek(0).type, lexer.getCodeBody());
    }
break;
case 203:
//#line 469 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      builder.beginMethod();
    }
break;
case 204:
//#line 471 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.returnType = val_peek(6).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(5).sval;
        mth.body = val_peek(0).sval;
        builder.endMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 205:
//#line 481 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      builder.beginMethod();
    }
break;
case 206:
//#line 483 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear();
        mth.returnType = val_peek(6).type;
        mth.dimensions = val_peek(2).ival;
        mth.name = val_peek(5).sval;
        mth.body = val_peek(0).sval;
        builder.endMethod(mth);
        mth = new MethodDef();
    }
break;
case 207:
//#line 495 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
      builder.beginMethod();
    }
break;
case 208:
//#line 497 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        mth.lineNumber = line;
        mth.modifiers.addAll(modifiers); modifiers.clear(); 
        mth.constructor = true; mth.name = val_peek(4).sval;
        mth.body = val_peek(0).sval;
        builder.endMethod(mth);
        mth = new MethodDef(); 
    }
break;
case 212:
//#line 511 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 213:
//#line 512 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ mth.exceptions.add(val_peek(0).sval); }
break;
case 218:
//#line 521 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{
        param.name = val_peek(0).type.name;
        param.type = val_peek(2).type;
        param.dimensions = val_peek(0).type.dimensions;
        param.isVarArgs = val_peek(1).bval;
        builder.addParameter(param);
        param = new FieldDef();
    }
break;
case 219:
//#line 531 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.bval = false; }
break;
case 220:
//#line 532 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ yyval.bval = true; }
break;
case 222:
//#line 534 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ builder.addAnnotation((Annotation) val_peek(0).annoval); }
break;
case 224:
//#line 537 "D:\java-workspace\galileo\qdox\target\checkout/src/grammar/parser.y"
{ param.modifiers.add(val_peek(0).sval); }
break;
//#line 2099 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
